//
//  CeDesaturation.m
//  BitmapEffets
//
// Code source d'origine par Renaud Pradenc.
// Ce source a été créé pour la présentation de Cocoa Heads Paris (oct 2010).
// Vous êtes libres de le réutiliser, de le modifier et de le redistribuer.
// Soyez sympas: conservez simplement ce texte de présentation.



#import "CeDesaturation.h"


@implementation CeDesaturation

- (void) applyEffectDestBitmap:(PixelRGBx *)destBitmapPtr 
				  sourceBitmap:(PixelRGBx *)sourceBitmapPtr 
						 width:(NSUInteger)width 
						height:(NSUInteger)height
{
	PixelRGBx *sourcePixelPtr;
	PixelRGBx *destPixelPtr;
	
	NSUInteger x;
	NSUInteger y;
	UInt8 luminance;
	sourcePixelPtr = sourceBitmapPtr;
	destPixelPtr = destBitmapPtr;
	for(y = 0; y < height; y++)
	{
		for(x = 0; x < width; x++)
		{
			luminance = 0.3*(sourcePixelPtr->comp.r)
				+ 0.59 * (sourcePixelPtr->comp.g) 
				+ 0.11 * (sourcePixelPtr->comp.b);
			
			destPixelPtr->comp.r = luminance;
			destPixelPtr->comp.g = luminance;
			destPixelPtr->comp.b = luminance;
			
			sourcePixelPtr++;
			destPixelPtr++;
		}
	}
}

@end
