//
//  CeEffect.h
//  BitmapEffets
//
// Code source d'origine par Renaud Pradenc.
// Ce source a été créé pour la présentation de Cocoa Heads Paris (oct 2010).
// Vous êtes libres de le réutiliser, de le modifier et de le redistribuer.
// Soyez sympas: conservez simplement ce texte de présentation.

// ** Appliquer un effet à une image bitmap
// - Implémentez la méthode -[applyEffectDestBitmap:sourceBitmap:width:height:]. La CeEffectChain a réservé la mémoire pour sourceBitmap et destBitmap.
// - La méthode n'est appelée par la CeEffectChain que si 'enabled' = YES.



#import <Cocoa/Cocoa.h>

typedef union
{
	UInt32		all;
	
	struct 
	{
		UInt8	r;
		UInt8	g;
		UInt8	b;
		UInt8	x;
		
	} comp;	
	
	
} PixelRGBx;


@interface CeEffect : NSObject
{
	BOOL	enabled;	// YES: la chaîne applique l'effet à l'image
}

@property (readwrite)	BOOL enabled;


- (void) applyEffectDestBitmap:(PixelRGBx *)destBitmapPtr sourceBitmap:(PixelRGBx *)sourceBitmapPtr width:(NSUInteger)width height:(NSUInteger)height;

@end
