//
//  CeEffectChain.h
//  BitmapEffets
//
// Code source d'origine par Renaud Pradenc.
// Ce source a été créé pour la présentation de Cocoa Heads Paris (oct 2010).
// Vous êtes libres de le réutiliser, de le modifier et de le redistribuer.
// Soyez sympas: conservez simplement ce texte de présentation.


// ** Chaîne d'effets **
// - Ajoutez les effets avec -addEffect:
// - Fixez l'image source par la propriété 'sourceImage'
// - Lisez la propriété 'destImage' pour obtenir l'image sur laquelle ont été appliqués les effets.

// Quel que soit le format d'origine de l'image, tous les traitements sont effectués en RVB-, 8 bits par pixel.


#import <Cocoa/Cocoa.h>
#import "CeImage.h"
#import "CeEffect.h"



@interface CeEffectChain : NSObject
{
	CeImage 		*sourceImage;
	CGContextRef 	sourceContext;
	
	CeImage *destImage;
	
	NSMutableArray	*effects;
}

// MARK: Properties
@property (retain) 		CeImage *sourceImage;
@property (readonly) 	CeImage *destImage;


// MARK: Effects
- (void) addEffect:(CeEffect *)effect;
- (void) _applyEffects;

// MARK: Bitmaps and contexts handling
+ (CGContextRef) _createCGBitmapContextWithWidth:(NSUInteger)width height:(NSUInteger)height;
+ (void) _releaseCGBitmapContext:(CGContextRef)context;

@end
