//
//  CeImage.m
//  BitmapEffets
//
// Code source d'origine par Renaud Pradenc.
// Ce source a été créé pour la présentation de Cocoa Heads Paris (oct 2010).
// Vous êtes libres de le réutiliser, de le modifier et de le redistribuer.
// Soyez sympas: conservez simplement ce texte de présentation.



#import "CeImage.h"


@implementation CeImage

- (id) initWithImageAtURL:(NSURL *)url
{
	if(self = [super init])
	{
		CGImageSourceRef imageSource = CGImageSourceCreateWithURL((CFURLRef)url, nil);
		cgImage = CGImageSourceCreateImageAtIndex (imageSource, 
												   0, 				// image index
												   nil);			// options
		CFRelease(imageSource);
	}
	
	return self;
}

- (id) initWithCGBitmapContext:(CGContextRef)cgBitmapContext
{
	if(self = [super init])
	{
		cgImage = CGBitmapContextCreateImage(cgBitmapContext);
	}
	
	return self;
}

- (void) dealloc
{
	CGImageRelease(cgImage);
	
	[super dealloc];
}


- (void) drawInRect:(CGRect)rect
{
	CGContextRef cgContext = [[NSGraphicsContext currentContext] graphicsPort];
	CGContextDrawImage (cgContext, rect, cgImage);
}


- (void) drawInCGContext:(CGContextRef)theContext rect:(CGRect)rect
{
	CGContextDrawImage (theContext, rect, cgImage);
}


- (CGSize) size
{
	CGSize size;
	size.width = CGImageGetWidth(cgImage);
	size.height = CGImageGetHeight(cgImage);
	
	return size;	
}

@end
