//
//  CeNoise.m
//  BitmapEffets
//
// Code source d'origine par Renaud Pradenc.
// Ce source a été créé pour la présentation de Cocoa Heads Paris (oct 2010).
// Vous êtes libres de le réutiliser, de le modifier et de le redistribuer.
// Soyez sympas: conservez simplement ce texte de présentation.



#import "CeNoise.h"

@implementation CeNoise

- (id) init
{
	if(self = [super init])
	{
		noiseRatio = 0.5;
	}
	
	return self;
}

@synthesize noiseRatio;

- (void) applyEffectDestBitmap:(PixelRGBx *)destBitmapPtr 
				  sourceBitmap:(PixelRGBx *)sourceBitmapPtr 
						 width:(NSUInteger)width 
						height:(NSUInteger)height
{
	PixelRGBx *sourcePixelPtr;
	PixelRGBx *destPixelPtr;
	
	srand(1);	// Start the number generator again, so the result is the same across calls.
	
	NSUInteger x;
	NSUInteger y;
	sourcePixelPtr = sourceBitmapPtr;
	destPixelPtr = destBitmapPtr;
	for(y = 0; y < height; y++)
	{
		for(x = 0; x < width; x++)
		{
			// 0 <= noise <= 255
			UInt8 noise = ((float)rand() / RAND_MAX) * 255;

			float signalRatio = 1.0 - noiseRatio;
			destPixelPtr->comp.r 
				= signalRatio*sourcePixelPtr->comp.r + noiseRatio*noise;
			destPixelPtr->comp.g 
				= signalRatio*sourcePixelPtr->comp.g + noiseRatio*noise;
			destPixelPtr->comp.b 
				= signalRatio*sourcePixelPtr->comp.b + noiseRatio*noise;
			
			sourcePixelPtr++;
			destPixelPtr++;
		}
	}
}


@end
