//
//  MyDocument.h
//  BitmapEffets
//

// Code source d'origine par Renaud Pradenc.
// Ce source a été créé pour la présentation de Cocoa Heads Paris (oct 2010).
// Vous êtes libres de le réutiliser, de le modifier et de le redistribuer.
// Soyez sympas: conservez simplement ce texte de présentation.
 


#import <Cocoa/Cocoa.h>
#import "CeImage.h"
#import "CeBitmapView.h"
#import "CeEffectChain.h"

#import "CeDesaturation.h"
#import "CeNoise.h"
#import "CeConvolutionMatrix.h"

@interface MyDocument : NSDocument
{
	IBOutlet CeBitmapView *bitmapView;
	
	CeImage *sourceImage;
	CeEffectChain *effectChain;
	CeDesaturation *desaturation;
	CeNoise *noise;
	CeConvolutionMatrix *convolutionMatrix;
}
- (IBAction) applyEffects:(NSButton *)sender;
- (void) _updateBitmapView;

@end
