//
//  MyDocument.m
//  BitmapEffets
//

// Code source d'origine par Renaud Pradenc.
// Ce source a été créé pour la présentation de Cocoa Heads Paris (oct 2010).
// Vous êtes libres de le réutiliser, de le modifier et de le redistribuer.
// Soyez sympas: conservez simplement ce texte de présentation.


#import "MyDocument.h"


@implementation MyDocument

- (id)init
{
    self = [super init];
    if (self) 
	{
		// Les effets sont créés et ajoutés à la chaîne d'effets
		effectChain = [[CeEffectChain alloc] init];
		
		desaturation = [[CeDesaturation alloc] init];
		[effectChain addEffect:desaturation];
		[desaturation release];
		
		noise = [[CeNoise alloc] init];
		[effectChain addEffect:noise];
		[noise release];
		
		convolutionMatrix = [[CeConvolutionMatrix alloc] init];
		[effectChain addEffect:convolutionMatrix];
		[convolutionMatrix release];
    }
    return self;
}

- (void) dealloc
{
	[effectChain release];
	[sourceImage release];
	
	[super dealloc];
}

- (NSString *)windowNibName
{
    return @"MyDocument";
}

- (void)windowControllerDidLoadNib:(NSWindowController *) aController
{
    [super windowControllerDidLoadNib:aController];
	[self _updateBitmapView];
}

// Enregistrement de l'image
// Laissé en exercice au lecteur :-)
- (NSData *)dataOfType:(NSString *)typeName error:(NSError **)outError
{

    if ( outError != NULL ) {
		*outError = [NSError errorWithDomain:NSOSStatusErrorDomain code:unimpErr userInfo:NULL];
	}
	return nil;
}

// Lecture de l'image
- (BOOL)readFromURL:(NSURL *)absoluteURL ofType:(NSString *)typeName error:(NSError **)outError 
{
	sourceImage = [[CeImage alloc] initWithImageAtURL:absoluteURL];
	
    if ( outError != NULL ) {
		*outError = [NSError errorWithDomain:NSOSStatusErrorDomain code:unimpErr userInfo:NULL];
	}
    return YES;
}

// Appelée lorsque le bouton "Appliquer" est cliqué.
- (IBAction) applyEffects:(NSButton *)sender
{
	[self _updateBitmapView];	
}

// Fait passer la bitmaps source dans la chaîne d'effets et affiche l'image modifiée.
- (void) _updateBitmapView
{
	effectChain.sourceImage = sourceImage;
	bitmapView.bitmap = effectChain.destImage;
}

@end
